/* 
 *  Dynamixel pro operations for the XL-320
 */

#include <DynamixelPro.h>

DynamixelPro dxlEX(1);  // DXL PRO(485) on serial 3 USART

void setup() {
  SerialUSB.begin();         // Talk back to computer
  pinMode(BOARD_LED_PIN, OUTPUT);
  dxlEX.begin(3);            //57600 bps in DXL 2.0 table

  SerialUSB.print("Send any value to continue...\n");
  delay(5000);
  SerialUSB.print("Send any value to continue...\n");
  while(!SerialUSB.available())
  {
    digitalWrite(BOARD_LED_PIN, LOW);
    delay(1000);
    digitalWrite(BOARD_LED_PIN, HIGH);
    delay(1000);
  }

}

void loop() {
  int n,model;
  byte res = 0;

  for (n=0; n<16; n++) {
    model = dxlEX.readWord(n,0);
    res = dxlEX.getResult();
    if (res == COMM_RXSUCCESS){
      SerialUSB.print(n);
      SerialUSB.print(" : ");
      SerialUSB.println(model);
      MoveThisServo(n);
    }
    else {
      SerialUSB.print("res = ");SerialUSB.println(res);
    }
      
  }
  while(1);
}

int MoveThisServo(int addr)
{
  int n;
  
  dxlEX.writeByte(addr,24,1);    //Turn on Torque Enable
  dxlEX.writeWord(addr,32,128);  //Limit speed (128/2048)
  
  for (n=0; n<1; n++) {
    dxlEX.writeWord(addr,30,500);
    delay(1000);
    dxlEX.writeWord(addr,30,700);
    delay(1000);
  }
  dxlEX.writeWord(addr,30,50);
  
  return(0);
}
  
